
;;;  

(defun dv_t_r3d ( /     cpt   ept	 hdv   bdv
	       hp1   hp2   hp3	 lp1   rd1   rd2    
	       pt0   pt1   pt2   pt3	 pt4   pt5
	       pt6   pt7   pt8	 pt9   pt10  pt11  pt12	 pt13  pt14
	       pt15  pt16  pt17	 pt18  pt19  pt20  pt21  
	      )

  (setq
    hdv	(nth 1 bb)
    bdv	(nth 2 bb)
    hp1	(nth 3 bb)
    hp2	(nth 4 bb)
    hp3	(nth 5 bb)
    lp1	(nth 6 bb)
    rd1	(nth 7 bb)
    rd2	(nth 8 bb)
  ) ;_ end of setq


  (setq dlina (atof dlndt))

  (defun ris_dvt ()

;;; 

    (defun dvt_sc ()

      (setq cpt '(0.0 0.0))

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt0 (polar cpt (/ pi 2) (/ hdv 2.0000)))
      (setq pt1 (polar cpt 0 (/ bdv 2.0000)))
      (setq pt11 (polar cpt (/ pi 2) hdv))
      (setq pt10 (polar pt11 0 (/ bdv 2.0000)))
      (setq pt2 (polar pt1 (/ pi 2) lp1))
      (setq pt9 (polar pt10 (/ (* pi 3) 2) lp1))
      (setq pt8	(polar pt9
		       (/ (* pi 91) 72)
		       (* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt3	(polar pt2
		       (/ (* pi 53) 72)
		       (* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt4	(polar pt3
		       (/ (* pi 175) 180)
		       (/ (- (/ (- bdv hp3) 2.0000)
			     (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			  ) ;_ end of -
			  (cos (/ pi 36))
		       ) ;_ end of /
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt7	(polar pt8
		       (/ (* pi 185) 180)
		       (/ (- (/ (- bdv hp3) 2.0000)
			     (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			  ) ;_ end of -
			  (cos (/ pi 36))
		       ) ;_ end of /
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt5	(polar pt4
		       (/ (* pi 53) 72)
		       (* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt6	(polar pt7
		       (/ (* pi 91) 72)
		       (* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq

      (setq pt21 (polar pt10 pi bdv))
      (setq pt20 (polar pt1 pi bdv))
      (setq pt19 (polar pt20 (/ pi 2) lp1))
      (setq pt12 (polar pt21 (/ (* pi 3) 2) lp1))
      (setq pt13 (polar	pt12
			(/ (* pi 125) 72)
			(* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq
      (setq pt18 (polar	pt19
			(/ (* pi 19) 72)
			(* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt14 (polar pt13
		    (/ (* pi 71) 36)
		    (/ (- (/ (- bdv hp3) 2.0000)
			  (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
		       ) ;_ end of -
		       (cos (/ pi 36))
		    ) ;_ end of /
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt17 (polar pt18
		    (/ pi 36)
		    (/ (- (/ (- bdv hp3) 2.0000)
			  (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
		       ) ;_ end of -
		       (cos (/ pi 36))
		    ) ;_ end of /
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt16 (polar	pt17
			(/ (* pi 19) 72)
			(* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq
      (setq pt15 (polar	pt14
			(/ (* pi 125) 72)
			(* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq

      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")

      (command "_pline" pt2 pt1 pt20 pt19 "_a" pt18 "_l" pt17 "_a" pt16 "_l" pt15 
                        "_a" pt14 "_l" pt13 "_a" pt12 "_l" pt21 pt10 pt9 "_a" pt8 
                        "_l" pt7 "_a" pt6 "_l" pt5 "_a" pt4 "_l" pt3 "_a" pt2 "")

    );    dvt_sc

	  (dvt_sc)

   (if (eq (strlen 
                  (substr (substr (nth 0 bbb) 5) (+ (strlen (itoa (atoi (substr (nth 0 bbb) 5)))) 2))
            );strlen 
        4);eq
       (setq stepen 1) 
       (setq stepen 2) 
    );if

   (setq ves 
    (+ (atoi (substr (nth 0 bbb) 5)) ; 10
       (/ (atoi (substr (substr (nth 0 bbb) 5) (+ (strlen (itoa (atoi (substr (nth 0 bbb) 5)))) 2)))
          (expt 10.0 stepen) 
        );/
     );+
     ves (rtos (* ves (/ dlina 1000)) 2 2)
   );setq

    (setq gost (strcat (nth (atoi rr) aa) gost " " ves ""))
    (command "_extrude" (entlast) "" dlina "")
    (command "-hyperlink" "_insert" "_object" (entlast) "" "" "" gost)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (command "_move" (entlast) "" cpt pause)

  ) ;_ end of defun
;;;_end of RIS_DVT


	(ris_dvt)

  (setvar "cmdecho" cmd)
  (setvar "blipmode" blpm)

  (prin1)

) ;_end of defun DV_T_R
